var AB = {};
AB.inflateRaw = function (e, r) {
    return AB.F.inflate(e, r)
};
AB.readUintBE = function (e) {
    return (e[0] << 24 | e[1] << 16 | e[2] << 8 | e[3]) >>> 0
};
AB.inflate = function (e, r) {
    var a = new Uint8Array(e.slice(0, 6));
    if (a[0] == 120 && a[1] == 156) {
        var t = AB.readUintBE([a[2], a[3], a[4], a[5]]);
        r = new Uint8Array(t);
        if (e instanceof ArrayBuffer) {
            return AB.inflateRaw(new Uint8Array(e, 6, e.byteLength - 6), r)
        }
        return AB.inflateRaw(new Uint8Array(e.buffer, e.byteOffset + 6, e.length - 6), r)
    }
    return e
};
AB.F = {};
AB.F.inflate = function (e, r) {
    var a = Uint8Array;
    if (e[0] == 3 && e[1] == 0) return r ? r : new a(0);
    var t = AB.F,
        n = t._bitsF,
        o = t._bitsE,
        i = t._decodeTiny,
        f = t.makeCodes,
        l = t.codes2map,
        d = t._get17;
    var c = t.U;
    var s = r == null;
    if (s) r = new a(e.length >>> 2 << 3);
    var v = 0,
        u = 0,
        A = 0,
        p = 0,
        h = 0,
        w = 0,
        B = 0;
    var m = 0,
        y = 0;
    var L, F;
    while (v == 0) {
        v = n(e, y, 1);
        u = n(e, y + 1, 2);
        y += 3;
        if (u == 0) {
            if ((y & 7) != 0) y += 8 - (y & 7);
            var g = (y >>> 3) + 4,
                b = e[g - 4] | e[g - 3] << 8;
            if (s) r = AB.F._check(r, m + b);
            r.set(new a(e.buffer, e.byteOffset + g, b), m);
            y = g + b << 3;
            m += b;
            continue
        }
        if (s) r = AB.F._check(r, m + (1 << 17));
        if (u == 1) {
            L = c.flmap;
            F = c.fdmap;
            w = (1 << 9) - 1;
            B = (1 << 5) - 1
        }
        if (u == 2) {
            A = o(e, y, 5) + 257;
            p = o(e, y + 5, 5) + 1;
            h = o(e, y + 10, 4) + 4;
            y += 14;
            var _ = y;
            for (var C = 0; C < 38; C += 2) {
                c.itree[C] = 0;
                c.itree[C + 1] = 0
            }
            var U = 1;
            for (var C = 0; C < h; C++) {
                var k = o(e, y + C * 3, 3);
                c.itree[(c.ordr[C] << 1) + 1] = k;
                if (k > U) U = k
            }
            y += 3 * h;
            f(c.itree, U);
            l(c.itree, U, c.imap);
            L = c.lmap;
            F = c.dmap;
            y = i(c.imap, (1 << U) - 1, A + p, e, y, c.ttree);
            var O = t._copyOut(c.ttree, 0, A, c.ltree);
            w = (1 << O) - 1;
            var I = t._copyOut(c.ttree, A, p, c.dtree);
            B = (1 << I) - 1;
            f(c.ltree, O);
            l(c.ltree, O, L);
            f(c.dtree, I);
            l(c.dtree, I, F)
        }
        while (true) {
            var x = L[d(e, y) & w];
            y += x & 15;
            var H = x >>> 4;
            if (H >>> 8 == 0) {
                r[m++] = H
            } else if (H == 256) {
                break
            } else {
                var S = m + H - 254;
                if (H > 264) {
                    var E = c.ldef[H - 257];
                    S = m + (E >>> 3) + o(e, y, E & 7);
                    y += E & 7
                }
                var R = F[d(e, y) & B];
                y += R & 15;
                var T = R >>> 4;
                var M = c.ddef[T],
                    D = (M >>> 4) + n(e, y, M & 15);
                y += M & 15;
                if (s) r = AB.F._check(r, m + (1 << 17));
                while (m < S) {
                    r[m] = r[m++ - D];
                    r[m] = r[m++ - D];
                    r[m] = r[m++ - D];
                    r[m] = r[m++ - D]
                }
                m = S
            }
        }
    }
    return r.length == m ? r : r.slice(0, m)
};
AB.F._check = function (e, r) {
    var a = e.length;
    if (r <= a) return e;
    var t = new Uint8Array(Math.max(a << 1, r));
    t.set(e, 0);
    return t
};
AB.F._decodeTiny = function (e, r, a, t, n, o) {
    var i = AB.F._bitsE,
        f = AB.F._get17;
    var l = 0;
    while (l < a) {
        var d = e[f(t, n) & r];
        n += d & 15;
        var c = d >>> 4;
        if (c <= 15) {
            o[l] = c;
            l++
        } else {
            var s = 0,
                v = 0;
            if (c == 16) {
                v = 3 + i(t, n, 2);
                n += 2;
                s = o[l - 1]
            } else if (c == 17) {
                v = 3 + i(t, n, 3);
                n += 3
            } else if (c == 18) {
                v = 11 + i(t, n, 7);
                n += 7
            }
            var u = l + v;
            while (l < u) {
                o[l] = s;
                l++
            }
        }
    }
    return n
};
AB.F._copyOut = function (e, r, a, t) {
    var n = 0,
        o = 0,
        i = t.length >>> 1;
    while (o < a) {
        var f = e[o + r];
        t[o << 1] = 0;
        t[(o << 1) + 1] = f;
        if (f > n) n = f;
        o++
    }
    while (o < i) {
        t[o << 1] = 0;
        t[(o << 1) + 1] = 0;
        o++
    }
    return n
};
AB.F.makeCodes = function (e, r) {
    var a = AB.F.U;
    var t = e.length;
    var n, o, i, f, l;
    var d = a.bl_count;
    for (var f = 0; f <= r; f++) d[f] = 0;
    for (f = 1; f < t; f += 2) d[e[f]]++;
    var c = a.next_code;
    n = 0;
    d[0] = 0;
    for (o = 1; o <= r; o++) {
        n = n + d[o - 1] << 1;
        c[o] = n
    }
    for (i = 0; i < t; i += 2) {
        l = e[i + 1];
        if (l != 0) {
            e[i] = c[l];
            c[l]++
        }
    }
};
AB.F.codes2map = function (e, r, a) {
    var t = e.length;
    var n = AB.F.U,
        o = n.rev15;
    for (var i = 0; i < t; i += 2)
        if (e[i + 1] != 0) {
            var f = i >> 1;
            var l = e[i + 1],
                d = f << 4 | l;
            var c = r - l,
                s = e[i] << c,
                v = s + (1 << c);
            while (s != v) {
                var u = o[s] >>> 15 - r;
                a[u] = d;
                s++
            }
        }
};
AB.F.revCodes = function (e, r) {
    var a = AB.F.U.rev15,
        t = 15 - r;
    var n = e.length;
    for (var o = 0; o < n; o += 2) {
        var i = e[o] << r - e[o + 1];
        e[o] = a[i] >>> t
    }
};
AB.F._putsE = function (e, r, a) {
    a = a << (r & 7);
    var t = r >>> 3;
    e[t] |= a;
    e[t + 1] |= a >>> 8
};
AB.F._putsF = function (e, r, a) {
    a = a << (r & 7);
    var t = r >>> 3;
    e[t] |= a;
    e[t + 1] |= a >>> 8;
    e[t + 2] |= a >>> 16
};
AB.F._bitsE = function (e, r, a) {
    return (e[r >>> 3] | e[(r >>> 3) + 1] << 8) >>> (r & 7) & (1 << a) - 1
};
AB.F._bitsF = function (e, r, a) {
    return (e[r >>> 3] | e[(r >>> 3) + 1] << 8 | e[(r >>> 3) + 2] << 16) >>> (r & 7) & (1 << a) - 1
};
AB.F._get17 = function (e, r) {
    return (e[r >>> 3] | e[(r >>> 3) + 1] << 8 | e[(r >>> 3) + 2] << 16) >>> (r & 7)
};
AB.F._get25 = function (e, r) {
    return (e[r >>> 3] | e[(r >>> 3) + 1] << 8 | e[(r >>> 3) + 2] << 16 | e[(r >>> 3) + 3] << 24) >>> (r & 7)
};
AB.F.U = function () {
    var e = Uint16Array,
        r = Uint32Array;
    return {
        next_code: new e(16),
        bl_count: new e(16),
        ordr: [16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15],
        of0: [3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 15, 17, 19, 23, 27, 31, 35, 43, 51, 59, 67, 83, 99, 115, 131, 163, 195, 227, 258, 999, 999, 999],
        exb: [0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 0, 0, 0, 0],
        ldef: new e(32),
        df0: [1, 2, 3, 4, 5, 7, 9, 13, 17, 25, 33, 49, 65, 97, 129, 193, 257, 385, 513, 769, 1025, 1537, 2049, 3073, 4097, 6145, 8193, 12289, 16385, 24577, 65535, 65535],
        dxb: [0, 0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9, 10, 10, 11, 11, 12, 12, 13, 13, 0, 0],
        ddef: new r(32),
        flmap: new e(512),
        fltree: [],
        fdmap: new e(32),
        fdtree: [],
        lmap: new e(32768),
        ltree: [],
        ttree: [],
        dmap: new e(32768),
        dtree: [],
        imap: new e(512),
        itree: [],
        rev15: new e(1 << 15),
        lhst: new r(286),
        dhst: new r(30),
        ihst: new r(19),
        lits: new r(15e3),
        strt: new e(1 << 16),
        prev: new e(1 << 15)
    }
}();
(function () {
    var e = AB.F.U;
    var r = 1 << 15;
    for (var a = 0; a < r; a++) {
        var t = a;
        t = (t & 2863311530) >>> 1 | (t & 1431655765) << 1;
        t = (t & 3435973836) >>> 2 | (t & 858993459) << 2;
        t = (t & 4042322160) >>> 4 | (t & 252645135) << 4;
        t = (t & 4278255360) >>> 8 | (t & 16711935) << 8;
        e.rev15[a] = (t >>> 16 | t << 16) >>> 17
    }

    function n(e, r, a) {
        while (r-- != 0) e.push(0, a)
    }
    for (var a = 0; a < 32; a++) {
        e.ldef[a] = e.of0[a] << 3 | e.exb[a];
        e.ddef[a] = e.df0[a] << 4 | e.dxb[a]
    }
    n(e.fltree, 144, 8);
    n(e.fltree, 255 - 143, 9);
    n(e.fltree, 279 - 255, 7);
    n(e.fltree, 287 - 279, 8);
    AB.F.makeCodes(e.fltree, 9);
    AB.F.codes2map(e.fltree, 9, e.flmap);
    AB.F.revCodes(e.fltree, 9);
    n(e.fdtree, 32, 5);
    AB.F.makeCodes(e.fdtree, 5);
    AB.F.codes2map(e.fdtree, 5, e.fdmap);
    AB.F.revCodes(e.fdtree, 5);
    n(e.itree, 19, 0);
    n(e.ltree, 286, 0);
    n(e.dtree, 30, 0);
    n(e.ttree, 320, 0)
})();
var Loader = Laya.Loader;
Loader.prototype["parsePLFBData"] = function (e) {
    var r = new Laya.Byte(AB.inflate(e));
    var a, t;
    t = r.getInt32();
    for (a = 0; a < t; a++) {
        this.parseOnePLFBFile(r)
    }
};
let rawOnLoaded = Loader.prototype["onLoaded"];
Loader.prototype["onLoaded"] = function (e = null) {
    var r = this._type;
    if (r == Loader.JSON && e instanceof ArrayBuffer) {
        e = JSON.parse(this.Utf8ArrayToStr(new Uint8Array(e)));
        this.complete(e)
    } else {
        rawOnLoaded.call(this, e)
    }
};
let rawLoadHtmlImage = Laya.Loader.prototype["_loadHtmlImage"];
Laya.Loader.prototype["_loadHtmlImage"] = function (e, r, a, t, n) {
    if (Loader.preLoadedMap[e]) {
        if (window["Blob"] && window["FileReader"]) {
            this.createHtmlImageAsync(Loader.preLoadedMap[e], e, r, a, t, n)
        } else {
            let o = this.arrayBufferToBase64(e, Loader.preLoadedMap[e]);
            rawLoadHtmlImage.call(this, o, r, a, t, n)
        }
    } else {
        rawLoadHtmlImage.call(this, e, r, a, t, n)
    }
};
Loader.prototype["createHtmlImageAsync"] = function (e, r, a, t, n, o) {
    let i;

    function f() {
        var e = i;
        e.onload = null;
        e.onerror = null;
        delete Laya.Loader["_imgCache"][r]
    }
    var l = function () {
        f();
        o.call(n)
    };
    var d = function () {
        f();
        t.call(a, i)
    };
    i = new Laya.Browser.window.Image;
    i.crossOrigin = "";
    i.onload = d;
    i.onerror = l;
    let c = new Blob([e]);
    let s = new FileReader;
    s.onload = function (e) {
        i.src = e.target.result;
        Laya.Loader["_imgCache"] = i
    };
    s.readAsDataURL(c)
};
Loader.prototype["arrayBufferToBase64"] = function (e, r) {
    let a = Laya.Utils.getFileExtension(e);
    let t = "data:image/jpeg;base64,";
    if (a == "png") t = "data:image/png;base64,";
    let n = "";
    let o = new Uint8Array(r);
    let i = o.byteLength;
    for (let e = 0; e < i; e++) {
        n += String.fromCharCode(o[e])
    }
    let f;
    if (window["btoa"]) {
        f = window.btoa(n)
    } else {
        f = this.btoa(n)
    }
    return t + f
};
Loader.prototype["btoa"] = function (e) {
    var r, a, t;
    var n = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    var o = 0,
        i = e.length,
        f = "";
    while (o < i) {
        r = e.charCodeAt(o++) & 255;
        if (o == i) {
            f += n.charAt(r >> 2);
            f += n.charAt((r & 3) << 4);
            f += "==";
            break
        }
        a = e.charCodeAt(o++);
        if (o == i) {
            f += n.charAt(r >> 2);
            f += n.charAt((r & 3) << 4 | (a & 240) >> 4);
            f += n.charAt((a & 15) << 2);
            f += "=";
            break
        }
        t = e.charCodeAt(o++);
        f += n.charAt(r >> 2);
        f += n.charAt((r & 3) << 4 | (a & 240) >> 4);
        f += n.charAt((a & 15) << 2 | (t & 192) >> 6);
        f += n.charAt(t & 63)
    }
    return f
};
Loader.prototype["Utf8ArrayToStr"] = function (e) {
    var r, a, t, n;
    var o, i;
    r = "";
    t = e.length;
    a = 0;
    while (a < t) {
        n = e[a++];
        switch (n >> 4) {
            case 0:
            case 1:
            case 2:
            case 3:
            case 4:
            case 5:
            case 6:
            case 7:
                r += String.fromCharCode(n);
                break;
            case 12:
            case 13:
                o = e[a++];
                r += String.fromCharCode((n & 31) << 6 | o & 63);
                break;
            case 14:
                o = e[a++];
                i = e[a++];
                r += String.fromCharCode((n & 15) << 12 | (o & 63) << 6 | (i & 63) << 0);
                break
        }
    }
    return r
};
let camera_parse = Laya.Camera.prototype["_parse"];
Laya.Camera.prototype["_parse"] = function (e, r) {
    e.enableHDR = false;
    camera_parse.call(this, e, r)
};